from venv import logger

from utils.mysql_db import MysqlHelper


class sqlCollect():
    """查询该账号是否存在"""
    @classmethod
    def select_hour_data(cls):

        sql = """SELECT video_id, video_title, create_time
                FROM crawler_video
                WHERE create_time >= DATE_SUB(NOW(), INTERVAL 1 HOUR)
                  AND create_time < NOW() AND video_title LIKE '%早%';"""
        try:
            data = MysqlHelper.get_values(sql)
            if data:
                data_list = [{"video_id": row[0], "video_title": row[1], "create_time": str(row[2])} for row in data]
                return data_list
            return None
        except Exception as e:
            logger.error(f"查询数据时发生异常: {e}")
            return None
